mod servek;

use serde::{Deserialize, Serialize};
use servek::Server;

#[derive(Clone, Copy, Serialize, Deserialize)]
pub enum ActivityKind {
    Create,
    Like,
    Note,
}

#[derive(Clone, Serialize, Deserialize)]
pub struct ActivityLD {
    pub context_uri: String,
    pub kind: ActivityKind,
    pub actor_uri: String,
    pub to_uris: Vec<String>,
    pub object: Option<ObjectLD>,
}

#[derive(Clone, Serialize, Deserialize)]
pub struct ObjectLD {
    pub context_uri: String,
    pub id: Option<String>,
    pub kind: Option<ActivityKind>,
    pub attributed_to: Option<String>,
    pub published: Option<String>,
    pub content: Option<String>,
}

#[tokio::main]
async fn main() -> Result<(), anyhow::Error> {
    Server::new().listen_and_serve(8008).await;

    Ok(())
}
